ru.yandex.clickhouse.util

## Class ClickHouseRowBinaryStream

- java.lang.Object
- - ru.yandex.clickhouse.util.ClickHouseRowBinaryStream

    public class ClickHouseRowBinaryStream
    extends Object

Author:
  Dmitry Andreev

### Constructor Summary

Constructors
Constructor and Description
`ClickHouseRowBinaryStream(OutputStream outputStream, TimeZone timeZone, ClickHouseProperties properties)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `markNextNullable(boolean isNullable)` Write a marker indicating if value is nullable or not.
`void` `writeByte(byte b)` Dangerous.
`void` `writeBytes(byte[] bytes)` Dangerous.
`void` `writeDate(Date date)`
`void` `writeDateArray(Date[] dates)`
`void` `writeDateTime(Date date)`
`void` `writeDateTimeArray(Date[] dates)`
`void` `writeFloat32(float value)`
`void` `writeFloat32Array(float[] floats)`
`void` `writeFloat64(double value)`
`void` `writeFloat64Array(double[] doubles)`
`void` `writeInt16(int value)`
`void` `writeInt16(short value)`
`void` `writeInt16Array(short[] shorts)`
`void` `writeInt32(int value)`
`void` `writeInt32Array(int[] ints)`
`void` `writeInt64(long value)`
`void` `writeInt64Array(long[] longs)`
`void` `writeInt8(byte value)`
`void` `writeInt8(int value)`
`void` `writeInt8Array(byte[] bytes)`
`void` `writeInt8Array(int[] ints)`
`void` `writeString(String string)`
`void` `writeStringArray(String[] strings)`
`void` `writeUInt16(int value)`
`void` `writeUInt16Array(int[] ints)`
`void` `writeUInt32(long value)`
`void` `writeUInt32Array(long[] longs)`
`void` `writeUInt64(long value)`
`void` `writeUInt64(com.google.common.primitives.UnsignedLong value)`
`void` `writeUInt64Array(long[] longs)`
`void` `writeUInt8(boolean value)`
`void` `writeUInt8(int value)`
`void` `writeUInt8Array(int[] ints)`
`void` `writeUnsignedLeb128(int value)`
`void` `writeUUID(UUID uuid)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ClickHouseRowBinaryStream

    public ClickHouseRowBinaryStream(OutputStream outputStream,
                                     TimeZone timeZone,
                                     ClickHouseProperties properties)

### Method Detail

#### writeUnsignedLeb128

    public void writeUnsignedLeb128(int value)
                             throws IOException

Throws:
  `IOException`

#### writeBytes

    public void writeBytes(byte[] bytes)
                    throws IOException

Dangerous. Can only be used for rare optimizations, for example when the string is written in parts without prior concatenation. The size of the string in bytes must be passed through writeUnsignedLeb128.

Parameters:
  `bytes` -
Throws:
  `IOException`

#### writeByte

    public void writeByte(byte b)
                   throws IOException

Dangerous. Can only be used for rare optimizations, for example when the string is written in parts without prior concatenation. The size of the string in bytes must be passed through writeUnsignedLeb128.

Parameters:
  `b` -
Throws:
  `IOException`

#### writeString

    public void writeString(String string)
                     throws IOException

Throws:
  `IOException`

#### writeUInt8

    public void writeUInt8(boolean value)
                    throws IOException

Throws:
  `IOException`

#### writeUInt8

    public void writeUInt8(int value)
                    throws IOException

Throws:
  `IOException`

#### writeInt8

    public void writeInt8(int value)
                   throws IOException

Throws:
  `IOException`

#### writeInt8

    public void writeInt8(byte value)
                   throws IOException

Throws:
  `IOException`

#### writeInt16

    public void writeInt16(int value)
                    throws IOException

Throws:
  `IOException`

#### writeInt16

    public void writeInt16(short value)
                    throws IOException

Throws:
  `IOException`

#### writeUInt16

    public void writeUInt16(int value)
                     throws IOException

Throws:
  `IOException`

#### writeInt32

    public void writeInt32(int value)
                    throws IOException

Throws:
  `IOException`

#### writeUInt32

    public void writeUInt32(long value)
                     throws IOException

Throws:
  `IOException`

#### writeInt64

    public void writeInt64(long value)
                    throws IOException

Throws:
  `IOException`

#### writeUInt64

    public void writeUInt64(long value)
                     throws IOException

Throws:
  `IOException`

#### writeUInt64

    public void writeUInt64(com.google.common.primitives.UnsignedLong value)
                     throws IOException

Throws:
  `IOException`

#### writeDateTime

    public void writeDateTime(Date date)
                       throws IOException

Throws:
  `IOException`

#### writeDate

    public void writeDate(Date date)
                   throws IOException

Throws:
  `IOException`

#### writeFloat32

    public void writeFloat32(float value)
                      throws IOException

Throws:
  `IOException`

#### writeFloat64

    public void writeFloat64(double value)
                      throws IOException

Throws:
  `IOException`

#### writeDateArray

    public void writeDateArray(Date[] dates)
                        throws IOException

Throws:
  `IOException`

#### writeDateTimeArray

    public void writeDateTimeArray(Date[] dates)
                            throws IOException

Throws:
  `IOException`

#### writeStringArray

    public void writeStringArray(String[] strings)
                          throws IOException

Throws:
  `IOException`

#### writeInt8Array

    public void writeInt8Array(byte[] bytes)
                        throws IOException

Throws:
  `IOException`

#### writeInt8Array

    public void writeInt8Array(int[] ints)
                        throws IOException

Throws:
  `IOException`

#### writeUInt8Array

    public void writeUInt8Array(int[] ints)
                         throws IOException

Throws:
  `IOException`

#### writeInt16Array

    public void writeInt16Array(short[] shorts)
                         throws IOException

Throws:
  `IOException`

#### writeUInt16Array

    public void writeUInt16Array(int[] ints)
                          throws IOException

Throws:
  `IOException`

#### writeInt32Array

    public void writeInt32Array(int[] ints)
                         throws IOException

Throws:
  `IOException`

#### writeUInt32Array

    public void writeUInt32Array(long[] longs)
                          throws IOException

Throws:
  `IOException`

#### writeInt64Array

    public void writeInt64Array(long[] longs)
                         throws IOException

Throws:
  `IOException`

#### writeUInt64Array

    public void writeUInt64Array(long[] longs)
                          throws IOException

Throws:
  `IOException`

#### writeFloat32Array

    public void writeFloat32Array(float[] floats)
                           throws IOException

Throws:
  `IOException`

#### writeFloat64Array

    public void writeFloat64Array(double[] doubles)
                           throws IOException

Throws:
  `IOException`

#### markNextNullable

    public void markNextNullable(boolean isNullable)
                          throws IOException

Write a marker indicating if value is nullable or not. E.g., to write Nullable(Int32): {{{ void writeNullableInt32(Integer value) { if (value == null) { markNextNullable(true); } else { markNextNullable(false); writeInt32(value); } } }}}

Throws:
  `IOException`

#### writeUUID

    public void writeUUID(UUID uuid)
                   throws IOException

Throws:
  `IOException`